#include "axis.h"

class CPlot {
    static const int mLin = 80;
 public:
    uint iPlot;
    CAxis X, Y;
    // options for data plotting:
    uint maxpoints;
    bool with_errors;
    // options for curve plotting:
    uint equipoints;
    bool refine;

    CPlot( uint _iPlot, bool _logx, bool _logy );

    void gp_write( string );
    void clearFrame();
    void plotFrame( string xlabel, string ylabel );
    void addSpec( bool as_line, int style_no,
                  const vector<double>& xp,
                  const vector<double>& yp, const vector<double>& dyp,
                  const vector<double>& z,
                  string xco, string yco, string info );
    void showSpecs();
    void plotDoclines( const vector<string>& lDoc );
    void writePostscript( string ps_outdir, string ps_head, string ps_dict );
    void setAux( string cmd );
    string info() const;

private:
    int gp_fifo;
    int gp_fno;
    string gp_fnames;

    uint ps_fnum; // file
    uint ps_snum; // spectrum
    uint ps_pnum; // spectrum with pstyle
    uint ps_cnum; // spectrum with cstyle
    void ps_ticktack( uint ntack, double *tack, int ntpt, double *ticklim,
                      CAxis *A );
    vector<string> ps_Doc;
    vector<string> ps_accu; // future output is accumulated here
    char outlin[ mLin ];
};

namespace NPloWin {
    extern vector<CPlot*> Plots;
    extern uint nPlot, iPlot;

    void initialize();
};
